_msg2 = msg2

function msg2(id, txt)
	_msg2(id, InsertTags(id,txt))
end

function msg(txt)
	for _, id in pairs(player(0,"table")) do
		msg2(id, txt)
	end
	if game("dedicated") then
		print(txt)
	end
end

function tag_usgn(id)
	return USGNName(tonumber(id)) or Color(255,0,0).."trans:333"..Color(255,255,0)
end

function tag_user(id)
	return PlayerName(tonumber(id)) or Color(255,0,0).."trans:332"..Color(255,255,0)
end

function tag_item(id)
	local name = ItemName(tonumber(id))
	if name then
		return Color(0,255,0)..name..Color(255,255,0)
	end
	return Color(255,0,0).."trans:331"..Color(255,255,0)
end

function tag_translation(id)
	return function (msgid,argstring)
		local argstring = argstring or ""
		local args = {}
		local split = argstring:split("")
		for i = 1, #split do
			local n = tonumber(split[i])
			if n then
				table.insert(args, n)
			else
				table.insert(args, split[i])
			end
		end
		return Translate(id, tonumber(msgid), unpack(args))
	end
end

function InsertTags(id,realText)
	local text = realText
	text = string.gsub(text, "usgn:(%d+)", tag_usgn)
	text = string.gsub(text, "player:(%d+)", tag_user)
	text = string.gsub(text, "item:(%d+)", tag_item)

	-- Translation tags
	text = string.gsub(text, "trans:(%d+)%((.+)%)", tag_translation(id))
	text = string.gsub(text, "trans:(%d+)%(%)", tag_translation(id))
	text = string.gsub(text, "trans:(%d+)", tag_translation(id))
	return text
end

function Color(r,g,b)
	if not r then r = 0 end
	if not g then g = 0 end
	if not b then b = 0 end
	local r,g,b = tostring(r),tostring(g),tostring(b)
	while string.len(r) < 3 do r = "0"..r end
	while string.len(g) < 3 do g = "0"..g end
	while string.len(b) < 3 do b = "0"..b end
	if string.len(r) == 3 and string.len(g) == 3 and string.len(b) == 3 then
		return ""..r..g..b
	end
	return "255255255"
end

function msgc(txt,r,g,b)
	msg(Color(r,g,b)..txt)
end

function msgc2(id,txt,r,g,b)
	if id and player(id, "exists") then
		if r or g or b then
			msg2(id, Color(r,g,b)..txt)
		else
			msg2(id, txt)
		end
	end
end

function Warning(txt)
	for _, id in pairs(player(0,"table")) do
		Warning2(id, txt)
	end
end

function Warning2(id,txt)
	msgc2(id, "[Warning] "..Color(255,255,0)..txt, 255)
end

function RankMSG(lvl,txt,r,g,b)
	for _, id in pairs(player(0,"table")) do
		if PlayerLevel(id) >= lvl then
			msgc2(id, txt, r, g, b)
		end
	end
end

function ServerMSG(txt)
	for _, id in pairs(player(0,"table")) do
		ServerMSG2(id, txt)
	end
end

function ServerBroadcast(txt)
	msgc("[trans:334] "..Color(255,255,0)..txt, 255, 100)
end

function ServerMSG2(id,txt)
	if id and player(id, "exists") then
		msgc2(id, "[trans:335] "..Color(255,255,0)..txt, 0, 255, 100)
	end
end

function ErrorMSG(id,txt)
	if id and player(id, "exists") then
		msgc2(id, "[trans:336] "..Color(255,255,0)..txt, 255, 0, 0)
	end
end

function printc(txt,r,g,b)
	print(Color(r,g,b)..txt)
end
